<?php

include_once 'Paygine.php';

class Pactioner extends Actioner {
	
	public function notification(){
		try {
			// Получаем оплату плагина
			$payment = Models_Payment::getPaymentByPlugin(Paygine::$pluginName);
			$payment_param = $payment['paramArray'];
			$pc_operation = [];
			$request_body = file_get_contents("php://input");
			$pc_operation = Paygine::parseXML($request_body);
			Paygine::responseValidation($pc_operation, $payment_param);
			if($pc_operation['state'] !== Paygine::OPERATION_APPROVED)
				throw new Exception('Operation no approved');
			$order_id = intval($pc_operation['reference']);
			$order = Paygine::getOrder($order_id, $payment['id']);
			if(!$order)
				throw new Exception('Can\'t find order by ID (reference)');
			$pc_order = Paygine::getOrderFromPc($pc_operation['order_id'], $payment_param);
			if(!$pc_order)
				throw new Exception('Can\'t get PC order by ID (order_id)');
			if((int) $pc_order['amount'] !== (Paygine::centify($order['summ']) + Paygine::centify($order['delivery_cost'])))
				throw new Exception('Incorrect order amount');
			
		} catch (Exception $e) {
			Paygine::log(__CLASS__ . '_' . __FUNCTION__, ['error' => $e->getMessage(), 'operation' => $pc_operation]);
			exit($e->getMessage());
		}
		
		$order_status = Paygine::getCustomOrderStatus($pc_order['state'], $payment_param);
		$orderModel = new Models_Order();
		if(method_exists($orderModel, 'updateOrder'))
			$orderModel->updateOrder(['id' => $order_id, 'status_id' => $order_status]);
		
		echo 'ok';
	}
	
}